#!/usr/bin/env python
from glob import glob
import sys
import pickle
import numpy as np
import matplotlib.pyplot as plt
ncase=sys.argv[1]
thevar=sys.argv[2]
thevar2=""
if len(sys.argv) > 3: thevar2 =sys.argv[3]
files=sorted(glob('../output/'+ncase+'/*.pkl'))
pinf=open(files[0],'rb')
f=pickle.load(pinf)
print(f.keys())
pinf.close()

zt='zu'
if len(f[thevar])==len(f['zf']): zt='zf'
print(thevar,zt)
field=[]
y=[]
ta=[]

if thevar2:
    zt2='zu'
    if len(f[thevar2])==len(f['zf']): zt2='zf'
    print(thevar2,zt2)
    field2=[]
    y2=[]

for pfile in files[0:]:
    pinf=open(pfile,'rb')
    f=pickle.load(pinf)
    time=f['ap']['TIME']
    print(pfile,time,max(f[thevar]))
    ta.append(time)
    field.append(f[thevar])
    y.append(f[zt])
    if thevar2:
        field2.append(f[thevar2])
        y2.append(f[zt2])

sa=np.array(field).T
ya=np.array(y).T
m=ya.shape[0]
m=50
print("m=",m)
print(sa.shape)
print(ya.max())
xa=0.*ya
for i in range(0,len(ta)):
    xa[:,i]=ta[i]
more,this=plt.subplots(figsize=[20,20])
cf=this.contourf(xa[:m,:],ya[:m,:],sa[:m,:],zorder=1,cmap='YlOrBr')
more.colorbar(cf,ax=this)
more.text(.82,.9,thevar,fontsize=18,ha='center')

# Overlay grid lines
this.plot(xa[:m,:], ya[:m,:], color="gray", linewidth=0.5,zorder=20)  # Horizontal grid lines
this.plot(xa[:m,:].T, ya[:m,:].T, color="gray", linewidth=0.5,zorder=21)  # Vertical grid lines


if thevar2:
    sa=np.array(field2).T
    ya=np.array(y2).T
    print(sa.shape)
    print(ya.max())
    xa=0.*ya
    for i in range(0,xa.shape[1]):
        xa[:,i]=ta[i]
    c2=this.contour(xa[:m,:],ya[:m,:],sa[:m,:],cmap='winter',zorder=10)
    more.colorbar(c2)#,ax=this)
    more.text(.69,.9,thevar2,fontsize=18,ha='center')
#    this.clabel(c2,inline=1,fontsize=10)

# Overlay grid points

plt.title(ncase,fontsize=24)

figname = ncase+thevar
if thevar2: figname += thevar2
figname='../output/'+ncase+'/'+figname+'.png'

plt.savefig(figname)
print("save figure: ",figname)

plt.show()



